/*
 * File:    fe_mul121666.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
#include "msp430fr5969.h"

.global fe_mul121666
.type fe_mul121666, @function

   
    
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

      
fe_mul121666:

      dint
      nop
    
      ; h = 121666 * f
      ; R15 holds pointer to h
      ; R14 holds pointer to f
      
      ; 121666 = 1 * 2^16 + 56130
       
      mov.w     #38,&MPY   
      mov.w     30(R14),&OP2
      mov.w     #56130,&MAC
      mov.w     @R14,&OP2
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,0(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,2(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,4(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,6(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,8(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,10(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,12(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,14(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,16(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,18(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,20(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,22(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,24(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
      
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,26(R15)
      mov.w     &RESLO,R12
      mov.w     &RESHI,&RESLO
      clr.w     &RESHI
     
      add.w     @R14+,&RESLO
      adc.w     &RESHI
      mov.w     @R14,&OP2
      mov.w     R12,28(R15)
      mov.w     &RESLO,30(R15)
      
      mov.w     #38,&MPY
      mov.w     &RESHI,&OP2
      
      add.w     &RESLO,0(R15)
      addc.w    &RESHI,2(R15)
      adc.w     4(R15)
      adc.w     6(R15)
      adc.w     8(R15)
      adc.w     10(R15)
      adc.w     12(R15)
      adc.w     14(R15)
      adc.w     16(R15)
      adc.w     18(R15)
      adc.w     20(R15)
      adc.w     22(R15)
      adc.w     24(R15)
      adc.w     26(R15)
      adc.w     28(R15)
      adc.w     30(R15)
      
      clr.w     R12
      adc.w     R12
      mov.w     R12,&OP2
      add.w     &RESLO,0(R15)

      eint
    
    ret
