/*
 * File:    fe_sq.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */

#include "msp430fr5969.h"  

.global fe_sq
.type fe_sq, @function

   
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

      
fe_sq:

    dint
    nop
    pushm.w     #8,R11
    push.w      R15
    sub         #96,R1
    
    mov         #RESLO,R12
    
    ; R14 holds f
    ; R13 holds g
    ; R1 (0 ... 30)   hold L = A_l * B_l
    ; R1 (32 ... 62)  hold H = A_h * B_h
    ; R1 (64 ... 78)  hold A_l - A_h
    ; R1 (80 ... 94)  hold B_l - B_h
    ; R1 (64 ... 94)  hold -M+L+H
  
; Computation of L = A_l * B_l

    add         #6,R14
    mov         @R14+,R4
    mov         @R14+,R5
    mov         @R14+,R6
    mov         @R14+,R7
    mov         @R14+,R8
    sub         #16,R14
    
    mov         @R14,&MPY
    mov         @R14+,&OP2
    mov         @R12+,0(R1)
    mov         @R12,R9
        
    clr         R15    
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R10
    mov         @R12,R11
    rla         R10
    rlc         R11
    rlc         R15
    add         R9,R10
    adc         R11
    adc         R15
    mov         R10,2(R1)

    clr         R13
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12,R10
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    sub         #4,R14
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #2,R12
    add         @R12+,R9
    addc        @R12,R10
    adc         R13
    mov         R9,4(R1)
    
    sub         #2,R14  
    mov         @R14+,&MPY
    mov         R4,&OP2
    mov         @R14+,&MAC
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,6(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,8(R1)
    
    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,10(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         @R12,R13
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R4,&MPY
    mov         R4,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,12(R1)
    
    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14+,&MAC
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    mov         R4,&MAC
    add         @R12,R15
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,14(R1)

    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14,&MAC
    mov         R7,&OP2
    mov         R4,&MAC
    mov         @R12,R13
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R5,&MPY
    mov         R5,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,16(R1)
    
    mov         @R14,&MPY
    mov         R8,&OP2
    mov         R4,&MAC
    mov         R7,&OP2
    mov         R5,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,18(R1)

    mov         R4,&MPY
    mov         R8,&OP2
    mov         R5,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R6,&MPY
    mov         R6,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,20(R1)
    
    mov         R5,&MPY
    mov         R8,&OP2
    mov         R6,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,22(R1)

    mov         R6,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R7,&MPY
    mov         R7,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,24(R1)
     
    mov         R7,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,26(R1)

    mov         R8,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         R11,R9
    addc        R15,R10
    mov         R9,28(R1)
    mov         R10,30(R1)

; Computation of H = A_h * B_h

    add         #18,R14
    mov         @R14+,R4
    mov         @R14+,R5
    mov         @R14+,R6
    mov         @R14+,R7
    mov         @R14+,R8
    sub         #16,R14
    
    mov         @R14,&MPY
    mov         @R14+,&OP2
    sub         #4,R12
    mov         @R12+,32(R1)
    mov         @R12,R9
        
    clr         R15    
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R10
    mov         @R12,R11
    rla         R10
    rlc         R11
    rlc         R15
    add         R9,R10
    adc         R11
    adc         R15
    mov         R10,34(R1)

    clr         R13
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12,R10
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    sub         #4,R14
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #2,R12
    add         @R12+,R9
    addc        @R12,R10
    adc         R13
    mov         R9,36(R1)
    
    sub         #2,R14  
    mov         @R14+,&MPY
    mov         R4,&OP2
    mov         @R14+,&MAC
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,38(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,40(R1)
    
    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,42(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         @R12,R13
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R4,&MPY
    mov         R4,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,44(R1)
    
    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14+,&MAC
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    mov         R4,&MAC
    add         @R12,R15
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,46(R1)

    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14,&MAC
    mov         R7,&OP2
    mov         R4,&MAC
    mov         @R12,R13
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R5,&MPY
    mov         R5,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,48(R1)
    
    mov         @R14,&MPY
    mov         R8,&OP2
    mov         R4,&MAC
    mov         R7,&OP2
    mov         R5,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,50(R1)

    mov         R4,&MPY
    mov         R8,&OP2
    mov         R5,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R6,&MPY
    mov         R6,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,52(R1)
    
    mov         R5,&MPY
    mov         R8,&OP2
    mov         R6,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,54(R1)

    mov         R6,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R7,&MPY
    mov         R7,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,56(R1)
     
    mov         R7,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,58(R1)

    mov         R8,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         R11,R9
    addc        R15,R10
    mov         R9,60(R1)
    mov         R10,62(R1)
    

; Set R14 and R13 to original value

    sub         #20,R14

; Computation of |A_l - A_h|

    clr         R15
         
    mov         @R14+,R9
    mov         @R14+,R10
    mov         @R14+,R11
    mov         @R14+,R4
    mov         @R14+,R5
    mov         @R14+,R6
    mov         @R14+,R7
    mov         @R14+,R8
         
    sub         @R14+,R9
    subc        @R14+,R10
    subc        @R14+,R11
    subc        @R14+,R4
    subc        @R14+,R5
    subc        @R14+,R6
    subc        @R14+,R7
    subc        @R14+,R8
    
    sbc         R15
        
    xor         R15,R9
    xor         R15,R10
    xor         R15,R11
    xor         R15,R4
    xor         R15,R5
    xor         R15,R6
    xor         R15,R7
    xor         R15,R8
         
    and         #1,R15
         
    add         R15,R9
    adc         R10
    adc         R11
    adc         R4
    adc         R5
    adc         R6
    adc         R7
    adc         R8
    
    mov         R9,82(R1)
    mov         R10,84(R1)
    mov         R11,86(R1)
    
    mov         R1,R14
    add         #82,R14
         

// Computation of M

    
    mov         @R14,&MPY
    mov         @R14+,&OP2
    sub         #4,R12
    mov         @R12+,64(R1)
    mov         @R12,R9
        
    clr         R15    
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R10
    mov         @R12,R11
    rla         R10
    rlc         R11
    rlc         R15
    add         R9,R10
    adc         R11
    adc         R15
    mov         R10,66(R1)

    clr         R13
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12,R10
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    sub         #4,R14
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #2,R12
    add         @R12+,R9
    addc        @R12,R10
    adc         R13
    mov         R9,68(R1)
    
    sub         #2,R14  
    mov         @R14+,&MPY
    mov         R4,&OP2
    mov         @R14+,&MAC
    mov         @R14+,&OP2
    sub         #2,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,70(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         @R14,&MPY
    mov         @R14,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,72(R1)
    
    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         R5,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R4,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,74(R1)

    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         R6,&OP2
    mov         @R14+,&MAC
    mov         @R12,R13
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R4,&MPY
    mov         R4,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,76(R1)
    
    sub         #6,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14+,&MAC
    mov         R7,&OP2
    mov         @R14+,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    mov         R4,&MAC
    add         @R12,R15
    mov         R5,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,78(R1)

    sub         #4,R14  
    mov         @R14+,&MPY
    mov         R8,&OP2
    mov         @R14,&MAC
    mov         R7,&OP2
    mov         R4,&MAC
    mov         @R12,R13
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R5,&MPY
    mov         R5,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,80(R1)
    
    mov         @R14,&MPY
    mov         R8,&OP2
    mov         R4,&MAC
    mov         R7,&OP2
    mov         R5,&MAC
    mov         @R12,R15
    mov         R6,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    add         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,82(R1)

    mov         R4,&MPY
    mov         R8,&OP2
    mov         R5,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R6,&MPY
    mov         R6,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,84(R1)
    
    mov         R5,&MPY
    mov         R8,&OP2
    mov         R6,&MAC
    mov         R7,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,86(R1)

    mov         R6,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    mov         @R12,R13
    rla         R9
    rlc         R10
    rlc         R13
    add         R11,R9
    addc        R15,R10
    adc         R13
    mov         R7,&MPY
    mov         R7,&OP2
    sub         #4,R12
    add         @R12+,R9
    addc        @R12+,R10
    adc         R13
    mov         R9,88(R1)
     
    mov         R7,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R11
    mov         @R12,R15
    rla         R9
    rlc         R11
    rlc         R15
    add         R10,R9
    addc        R13,R11
    adc         R15
    mov         R9,90(R1)

    mov         R8,&MPY
    mov         R8,&OP2
    sub         #4,R12
    mov         @R12+,R9
    mov         @R12+,R10
    add         R11,R9
    addc        R15,R10
    mov         R9,92(R1)
    mov         R10,94(R1)
    
; Computation of -M_hat

    mov         R1,R14
    add         #80,R14
    mov         @R14+,R4
    mov         @R14+,R5
    mov         @R14+,R6
    mov         @R14+,R7
    mov         @R14+,R8
    mov         @R14+,R9
    mov         @R14+,R10
    mov         @R14+,R11
    

    mov         #0xffff,R15
         
    xor         R15,64(R1)
    xor         R15,66(R1)
    xor         R15,68(R1)
    xor         R15,70(R1)
    xor         R15,72(R1)
    xor         R15,74(R1)
    xor         R15,76(R1)
    xor         R15,78(R1)
    xor         R15,R4
    xor         R15,R5
    xor         R15,R6
    xor         R15,R7
    xor         R15,R8
    xor         R15,R9
    xor         R15,R10
    xor         R15,R11
    
; add contents of 1 & R15 for two's complement and add F0*G0 to M_hat

    mov         R1,R14

    bis         #1,R2
        
    addc        @R14+,64(R1)
    addc        @R14+,66(R1)
    addc        @R14+,68(R1)
    addc        @R14+,70(R1)
    addc        @R14+,72(R1)
    addc        @R14+,74(R1)
    addc        @R14+,76(R1)
    addc        @R14+,78(R1)
    addc        @R14+,R4
    addc        @R14+,R5
    addc        @R14+,R6
    addc        @R14+,R7
    addc        @R14+,R8
    addc        @R14+,R9
    addc        @R14+,R10
    addc        @R14+,R11
    adc         R15

; add F1*G1 to M_hat

    add         @R14+,64(R1)
    addc        @R14+,66(R1)
    addc        @R14+,68(R1)
    addc        @R14+,70(R1)
    addc        @R14+,72(R1)
    addc        @R14+,74(R1)
    addc        @R14+,76(R1)
    addc        @R14+,78(R1)
    addc        @R14+,R4
    addc        @R14+,R5
    addc        @R14+,R6
    addc        @R14+,R7
    addc        @R14+,R8
    addc        @R14+,R9
    addc        @R14+,R10
    addc        @R14+,R11
    adc         R15
    
; add (F0*G0 + F0*G0 - M_hat) to result

    mov         R1,R13
    add         #32,R13

    add          @R14+,16(R1)
    addc         @R14+,18(R1)
    addc         @R14+,20(R1)
    addc         @R14+,22(R1)
    addc         @R14+,24(R1)
    addc         @R14+,26(R1)
    addc         @R14+,28(R1)
    addc         @R14+,30(R1)
    addc         @R13+,R4
    addc         @R13+,R5
    addc         @R13+,R6
    addc         @R13+,R7
    addc         @R13+,R8
    addc         @R13+,R9
    addc         @R13+,R10
    addc         @R13+,R11
    addc         R15,48(R1)
    adc          50(R1)
    adc          52(R1)
    adc          54(R1)
    adc          56(R1)
    adc          58(R1)
    adc          60(R1)
    adc          62(R1)


    ;;;;;;;;;;;;;;;;;;;;;;;
    ; Reduction
    ;;;;;;;;;;;;;;;;;;;;;;;
    
    ;mov         112(R1),R15
    mov         96(R1),R15
         
    mov         R1,R13
    add         #48,R13
    mov         #RESHI,R12
         
    mov         #38,&MAC
         
    mov         @R1+,&RESLO
    clr         &RESHI
    mov         R4,&OP2
    mov         &RESLO,0(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R5,&OP2
    mov         &RESLO,2(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R6,&OP2
    mov         &RESLO,4(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R7,&OP2
    mov         &RESLO,6(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R8,&OP2
    mov         &RESLO,8(R15)
    mov         @R12,&RESLO
    clr         &RESHI
    
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R9,&OP2
    mov         &RESLO,10(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R10,&OP2
    mov         &RESLO,12(R15)
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         R11,&OP2
    mov         &RESLO,R14
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R4
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R5
    mov         @R12,&RESLO
    clr         &RESHI
    
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R6
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R7
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R8
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R9
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R10
    mov         @R12,&RESLO
    clr         &RESHI
         
    add         @R1+,&RESLO
    adc         &RESHI
    mov         @R13+,&OP2
    mov         &RESLO,R11
         
    mov         #38,&MPY
    mov         @R12,&OP2
    
    clr         R13
    add         &RESLO,0(R15)
    adc         2(R15)
    adc         4(R15)
    adc         6(R15)
    adc         8(R15)
    adc         10(R15)
    adc         12(R15)
    adc         R14
    adc         R4
    adc         R5
    adc         R6
    adc         R7
    adc         R8
    adc         R9
    adc         R10
    adc         R11
    
    mov         R14,14(R15)
    mov         R4,16(R15)
    mov         R5,18(R15)
    mov         R6,20(R15)
    mov         R7,22(R15)
    mov         R8,24(R15)
    mov         R9,26(R15)
    mov         R10,28(R15)
    mov         R11,30(R15)

    adc         R13
    mov         R13,&OP2
    add         &RESLO,0(R15)
         
    add         #64,R1
    
    pop.w       R15
    popm.w      #8,R11
    eint
    
    ret

