/*
 * File:    compare.c
 * Author:  Gesine Hinterwlder
 * Version: Wed Oct 01 13:26:50 2014 +0200
 * Public Domain
 */

#include "msp430fr5969.h"

.global fe_sub
.type fe_sub, @function


    
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

fe_sub:

    dint
    nop

    ; h = f - g
    ; R15 holds pointer to h
    ; R14 holds pointer to f
    ; R13 holds pointer to g
    
    mov.w       @R14+,R12
    sub.w       @R13+,R12
    mov.w       R12,0(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,2(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,4(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,6(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,8(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,10(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,12(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,14(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,16(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,18(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,20(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,22(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,24(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,26(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,28(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,30(R15)
    
    ; Reduction:
    
    mov.w       R2,R12
    and.w       #1,R12
    mov.w       #1,R13
    sub.w       R12,R13
    mov.w       #38,&MPY
    mov.w       R13,&OP2
    
    sub.w       &RESLO,0(R15)
    sbc.w       2(R15)
    sbc.w       4(R15)
    sbc.w       6(R15)
    sbc.w       8(R15)
    sbc.w       10(R15)
    sbc.w       12(R15)
    sbc.w       14(R15)
    sbc.w       16(R15)
    sbc.w       18(R15)
    sbc.w       20(R15)
    sbc.w       22(R15)
    sbc.w       24(R15)
    sbc.w       26(R15)
    sbc.w       28(R15)
    sbc.w       30(R15)
    
    mov.w       R2,R12
    and.w       #1,R12
    mov.w       #1,R13
    sub.w       R12,R13
    mov.w       R13,&OP2
    sub.w       &RESLO,0(R15)
    
    eint

    ret
