/*
 * File:    fe_sub_25519.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
#include "msp430fr5969.h"

.global fe_sub_25519
.type fe_sub_25519, @function

 
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

    ; h = f - 2^255-19
    ; R14 holds pointer to f
    ; R15 holds pointer to h

fe_sub_25519:

    mov.w       @R14+,R12
    sub.w       #0xffed,R12
    mov.w       R12,0(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,2(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,4(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,6(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,8(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,10(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,12(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,14(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,16(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,18(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,20(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,22(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,24(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,26(R15)
                
    mov.w       @R14+,R12
    subc.w      #0xffff,R12
    mov.w       R12,28(R15)
                
    mov.w       @R14,R12
    subc.w      #0x7fff,R12
    mov.w       R12,30(R15)
    
    clr.w       R15    
    sbc.w       R15
    
    ret
