/*
 * File:    fe_add.S
 * Author:  Gesine Hinterwlder
            modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
#include "msp430fr5969.h"

.global fe_add
.type fe_add, @function
    

#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif


fe_add:
    dint
    nop
    push.w      R11
    
    ; h = g + f
    ; R15 holds pointer to h
    ; R14 holds pointer to f
    ; R13 holds pointer to g
    
    mov         30(R13),R12
    add         30(R14),R12
    clr         R11
    adc         R11
    
    rla         R12
    rlc         R11
    clrc
    rrc         R12
    mov         R12,30(R15)
    
    mov         R11,&MPY
    mov         #19,&OP2
    
    mov         @R13+,R11
    add         @R14+,R11
    clr         R12
    adc         R12
    add         &RESLO,R11
    mov         R11,0(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,2(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,4(R15)
                
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,6(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,8(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,10(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,12(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,14(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,16(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,18(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,20(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,22(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,24(R15)
    
    addc        @R13+,R12
    clr         R11
    adc         R11
    add         @R14+,R12
    mov         R12,26(R15)
    
    addc        @R13+,R11
    clr         R12
    adc         R12
    add         @R14+,R11
    mov         R11,28(R15)
    
    addc        R12,30(R15)
    
    pop.w       R11
    eint
    ret
