/*
 * File:    fe_mul121666.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
 #include "msp430fr5969.h"

.global fe_mul121666
.type fe_mul121666, @function


#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif


fe_mul121666:

      dint
      nop
    
      ; h = 121666 * f
      ; R15 holds pointer to h
      ; R14 holds pointer to f
      
      ; 121666 = 1 * 2^16 + 56130
      
      mov.w     #56130,&MPY32L
      mov.w     #1,&MPY32H
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      mov.w     #RES0,R13
      mov.w     @R13+,0(R15)
      mov.w     @R13+,2(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     #56130,&MAC32L
      mov.w     #1,&MAC32H
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,4(R15)
      mov.w     @R13+,6(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,8(R15)
      mov.w     @R13+,10(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,12(R15)
      mov.w     @R13+,14(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,16(R15)
      mov.w     @R13+,18(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,20(R15)
      mov.w     @R13+,22(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,24(R15)
      mov.w     @R13+,26(R15)
      mov.w     @R13+,&RES0
      mov.w     @R13+,&RES1
      clr.w     &RES2
      clr.w     &RES3
      
      mov.w     @R14+,&OP2L
      mov.w     @R14+,&OP2H
      sub.w     #8,R13
      mov.w     @R13+,28(R15)
      mov.w     @R13+,30(R15)
      
      mov.w     @R13+,&MPY32L
      mov.w     @R13+,&MPY32H
      mov.w     #38,&OP2L
      sub.w     #8,R13
      clr.w     R14
      
      add.w     @R13+,0(R15)
      addc.w    @R13+,2(R15)
      addc.w    @R13+,4(R15)
      adc.w     6(R15)
      adc.w     8(R15)
      adc.w     10(R15)
      adc.w     12(R15)
      adc.w     14(R15)
      adc.w     16(R15)
      adc.w     18(R15)
      adc.w     20(R15)
      adc.w     22(R15)
      adc.w     24(R15)
      adc.w     26(R15)
      adc.w     28(R15)
      adc.w     30(R15)
      
      adc.w     R14
      mov.w     R14,&OP2L
      add.w     &RES0,0(R15)
    
      eint
      ret
