/*
 * File:    fe_sq.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */

#include "msp430fr5969.h"  

.global fe_sq
.type fe_sq, @function
    
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

      
fe_sq:

    dint
    nop
    pushm.w     #8,R11
    push.w      R15
    
    sub         #96,R1

    bis         #MPYDLYWRTEN,&MPY32CTL0
    bic         #MPYDLY32,&MPY32CTL0

    ; h = f^2 
    ; R15 holds pointer to h
    ; R14 holds pointer to f
    ; R1 (0 ... 62) hold result
    
    mov         #RES0,R12
    mov         #SUMEXT,R15

    mov         R14,R13
    
    mov         @R13+,92(R1)
    mov         @R13+,94(R1)
    mov         @R13+,88(R1)
    mov         @R13+,90(R1)
    mov         @R13+,84(R1)
    mov         @R13+,86(R1)
    mov         @R13+,80(R1)
    mov         @R13+,82(R1)
    mov         @R13+,76(R1)
    mov         @R13+,78(R1)
    mov         @R13+,72(R1)
    mov         @R13+,74(R1)
    mov         @R13+,68(R1)
    mov         @R13+,70(R1)
    mov         @R13+,64(R1)
    mov         @R13+,66(R1)
    
    mov         R1,R13
    add         #92,R13
    
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R12+,0(R1)
    mov         @R12+,2(R1)
    mov         @R12+,R4
    mov         @R12+,R5
            
    mov         @R14+,&OP2L  
    mov         @R14+,&OP2H 
    sub         #8,R12
    sub         #8,R13
    mov         @R12+,R6
    mov         @R12+,R7
    mov         @R12+,R8
    mov         @R12+,R9
    clr         R10     
    rla         R6
    rlc         R7
    rlc         R8
    rlc         R9
    adc         R10
    add         R4,R6   
    addc        R5,R7
    adc         R8
    adc         R9
    adc         R10
    mov         R6,4(R1)
    mov         R7,6(R1)
    
    mov         @R14+,&OP2L  
    mov         @R14+,&OP2H 
    sub         #8,R14
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    clr         R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    adc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #12,R13
    sub         #8,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,8(R1)
    mov         R5,10(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #12,R13
    sub         #8,R14
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    mov         @R15,R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,12(R1)
    mov         R5,14(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    mov         @R15,R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    rlc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #16,R13
    sub         #12,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,16(R1)
    mov         R5,18(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H  
    mov         @R15,R10
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #16,R13
    sub         #12,R14
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    add         @R15,R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,20(R1)
    mov         R5,22(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R15,R11
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    add         @R15,R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    rlc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #20,R13
    sub         #16,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,24(R1)
    mov         R5,26(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R15,R10
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H  
    add         @R15,R10
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #16,R13
    sub         #12,R14
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    add         @R15,R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,28(R1)
    mov         R5,30(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R15,R11
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    add         @R15,R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    rlc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #16,R13
    sub         #12,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,32(R1)
    mov         R5,34(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R15,R10
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #12,R13
    sub         #8,R14
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    add         @R15,R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,36(R1)
    mov         R5,38(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    mov         @R15,R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    rlc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #12,R13
    sub         #8,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,40(R1)
    mov         R5,42(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    mov         @R14+,&MAC32L
    mov         @R14+,&MAC32H   
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #8,R13
    sub         #4,R14
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    mov         @R15,R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,44(R1)
    mov         R5,46(R1)
    
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R6
    mov         @R12+,R7
    clr         R11
    rla         R4
    rlc         R5
    rlc         R6
    rlc         R7
    rlc         R11
    add         R8,R4   
    addc        R9,R5
    addc        R10,R6
    adc         R7
    adc         R11
    mov         @R14+,&MPY32L
    mov         @R14+,&MPY32H
    mov         @R13+,&OP2L  
    mov         @R13+,&OP2H 
    sub         #8,R12
    sub         #8,R13
    sub         #4,R14
    add         @R12+,R4
    addc        @R12+,R5
    addc        @R12+,R6
    addc        @R12+,R7
    adc         R11
    mov         R4,48(R1)
    mov         R5,50(R1)
    
    mov         @R13+,&MPY32L
    mov         @R13+,&MPY32H
    mov         @R14+,&OP2L  
    mov         @R14+,&OP2H 
    sub         #8,R12
    mov         @R12+,R4
    mov         @R12+,R5
    mov         @R12+,R8
    mov         @R12+,R9
    clr         R10
    rla         R4
    rlc         R5
    rlc         R8
    rlc         R9
    rlc         R10
    add         R6,R4   
    addc        R7,R5
    addc        R11,R8
    adc         R9
    adc         R10
    mov         R4,R6
    mov         R5,R7
    
    mov         @R14+,&OP2L  
    mov         @R14+,&OP2H 
    sub         #8,R12
    clr         R4
    add         @R12+,R8
    addc        @R12+,R9
    addc        @R12+,R10
    addc        @R12+,R4
    mov         R8,R8
    mov         R9,R9
    mov         R10,R10
    mov         R4,R11
    
    
    ;;;;;;;;;;;;;;;;;;;;;;;
    ; Reduction
    ;;;;;;;;;;;;;;;;;;;;;;;
    
;    mov.w       112(R1),R15
    mov.w       96(R1),R15

    sub         #8,R12
    mov.w       #RES1,R14
    mov.w       #RES2,R13
    
    mov.w       R1,R4
    add.w       #32,R4
    
    clr.w       &RES2
    clr.w       &RES3
     
    mov.w       #38,&MAC32L
       
    mov.w       @R1+,&RES0
    mov.w       @R1+,&RES1
    mov.w       @R4+,&OP2L
    mov.w       @R4+,&OP2H
    mov.w       @R12,0(R15)
    mov.w       @R14,2(R15)
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       @R4+,&OP2L
    mov.w       @R4+,&OP2H
    mov.w       @R12,4(R15)
    mov.w       @R14,6(R15)
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       @R4+,&OP2L
    mov.w       @R4+,&OP2H
    mov.w       @R12,8(R15)
    mov.w       @R14,10(R15)
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       @R4+,&OP2L
    mov.w       @R4+,&OP2H
    mov.w       @R12,12(R15)
    mov.w       @R14,14(R15)
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       @R4+,&OP2L
    mov.w       @R4+,&OP2H
    mov.w       @R12,16(R15)
    mov.w       @R14,R5
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       R6,&OP2L
    mov.w       R7,&OP2H
    mov.w       @R12,R6
    mov.w       @R14,R7
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       R8,&OP2L
    mov.w       R9,&OP2H
    mov.w       @R12,R8
    mov.w       @R14,R9
    mov.w       @R13,&RES0
    clr.w       &RES1
    clr.w       &RES2
    
    add.w       @R1+,&RES0
    addc.w      @R1+,&RES1
    mov.w       R10,&OP2L
    mov.w       R11,&OP2H
    mov.w       @R12,R10
    mov.w       @R14,R11
    
    mov.w       #38,&MPY32L
    mov.w       @R13,&OP2L
    
    add.w       @R12,0(R15)
    adc.w       2(R15)
    adc.w       4(R15)
    adc.w       6(R15)
    adc.w       8(R15)
    adc.w       10(R15)
    adc.w       12(R15)
    adc.w       14(R15)
    adc.w       16(R15)
    adc.w       R5
    adc.w       R6
    adc.w       R7
    adc.w       R8
    adc.w       R9
    adc.w       R10
    adc.w       R11
    
    mov         R5,18(R15)
    mov         R6,20(R15)
    mov         R7,22(R15)
    mov         R8,24(R15)
    mov         R9,26(R15)
    mov         R10,28(R15)
    mov         R11,30(R15)
    
    clr.w       R11
    adc.w       R11
    mov.w       R11,&OP2L
    add.w       @R12,0(R15)

    add.w       #64,R1
    
    pop.w       R15
    popm.w      #8,R11
    eint
    
    ret
