/*
 * File:    fe_sub.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */

#include "msp430fr5969.h"

.global fe_sub
.type fe_sub, @function

   
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif


fe_sub:
    
;    dint
;    nop
    pushm.w     #8,R11
    
    ; h = f - g
    ; R15 holds pointer to h
    ; R14 holds pointer to f
    ; R13 holds pointer to g
    
    mov.w       @R14+,R4
    sub.w       @R13+,R4
                
    mov.w       @R14+,R5
    subc.w      @R13+,R5
                
    mov.w       @R14+,R6
    subc.w      @R13+,R6
                
    mov.w       @R14+,R7
    subc.w      @R13+,R7
                
    mov.w       @R14+,R8
    subc.w      @R13+,R8
                
    mov.w       @R14+,R9
    subc.w      @R13+,R9
                
    mov.w       @R14+,R10
    subc.w      @R13+,R10
                
    mov.w       @R14+,R11
    subc.w      @R13+,R11
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,16(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,18(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,20(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,22(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,24(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,26(R15)
                
    mov.w       @R14+,R12
    subc.w      @R13+,R12
    mov.w       R12,28(R15)
                
    mov.w       @R14+,R14
    subc.w      @R13+,R14
    
    ; Reduction:
    
    mov.w       R2,R12
    and.w       #1,R12
    mov.w       #0xffff,R13
    add.w       R12,R13
    and.w       #38,R13
    
    sub.w       R13,R4
    sbc.w       R5
    sbc.w       R6
    sbc.w       R7
    sbc.w       R8
    sbc.w       R9
    sbc.w       R10
    sbc.w       R11
    sbc.w       16(R15)
    sbc.w       18(R15)
    sbc.w       20(R15)
    sbc.w       22(R15)
    sbc.w       24(R15)
    sbc.w       26(R15)
    sbc.w       28(R15)
    sbc.w       R14
    
    mov.w       R2,R12
    and.w       #1,R12
    mov.w       #0xffff,R13
    add.w       R12,R13
    and.w       #38,R13
    
    sub.w       R13,R4
    
    mov         R4,0(R15)
    mov         R5,2(R15)
    mov         R6,4(R15)
    mov         R7,6(R15)
    mov         R8,8(R15)
    mov         R9,10(R15)
    mov         R10,12(R15)
    mov         R11,14(R15)
    mov         R14,30(R15)
     
    popm.w      #8,R11
;    eint
    ret
